## qtmoko 59

=== devices/c3200/DESCRIPTION ===
Device configuration profile providing support for Zaurus C3200 using angstrom dist.

=== devices/default/DESCRIPTION ===
This is a stub container for default files.

=== devices/greenphone/DESCRIPTION ===
Device configuration profile for the Greenphone.

=== devices/htcuniversal/DESCRIPTION ===
Support for HTC uniervsal devices.

=== devices/n800/DESCRIPTION ===
Device configuration profile providing support for the n800 device.

=== devices/n810/DESCRIPTION ===
Device configuration profile providing support for the n810 device.

=== devices/neo/DESCRIPTION ===
Support for s3c2410 based fic gta01 devices, including the Neo1973 (Openmoko).

=== devices/pc/DESCRIPTION ===
Support for GTA04 phone from goldelico.com, see http://projects.goldelico.com/p/gta04-main/

=== devices/reference/DESCRIPTION ===
This device is the simplist possible device that turns on all features in the build system.
For how this was done see the provided configure file.

=== devices/zaurusclamshell/DESCRIPTION ===
Device configuration profile providing support for Zaurus Clamshell

=== examples/ffmpeg/DESCRIPTION ===
Mediaengine plugin that wraps the ffmpeg media library.
- Requires ffmpeg installed into your system/toolchain.

=== examples/scribble/DESCRIPTION ===
A simple scribble/draw example application.

=== debian/changelog ===
qtmoko (59-1) unstable; urgency=low

  * fixed automatic suspend after inactivity

 -- Radek Polak <psonek2@seznam.cz>  Sun, 01 Dec 2013 21:16:00 +0100

qtmoko (58-1) unstable; urgency=low

  * gta02 kernel upgrade to 2.6.39
  * gta04 kernel upgrade to latest Neil's 3.7
  * hack to stop vibrating after resume
  * show end call button after 2s to avoid unwanted press
  * improved colors in qmplayer encoding
  * better name of encoded movie in qmplayer
  * using emdebian for some packages
  * using glamo-mplayer as package
  * suspend in locked screen is now after 3s

 -- Radek Polak <psonek2@seznam.cz>  Sun, 01 Dec 2013 21:16:00 +0100

qtmoko (57-1) unstable; urgency=low

  * clever charging for gta04
  * charging log
  * better sysfs for gta04 in neocontrol

 -- Radek Polak <psonek2@seznam.cz>  Sat, 14 Sep 2013 11:20:00 +0100

qtmoko (56-1) unstable; urgency=low

  * optimise removed messages on IMAP server (Neil Jerram)
  * gta04 - share-gprs.sh fix to use hso0 interface
  * fix bluetooth segfault when there is no adapter (Ivan Matveev)
  * fixes in FBReader

 -- Radek Polak <psonek2@seznam.cz>  Mon, 18 Mar 2013 19:55:00 +0100

qtmoko (55-1) unstable; urgency=low

  * gta02 - switch back to cruxus media engine

 -- Radek Polak <psonek2@seznam.cz>  Mon, 18 Mar 2013 19:55:00 +0100

qtmoko (54-1) unstable; urgency=low

  * gta02 - increase modem gsm net reg timeout so it registers ok

 -- Radek Polak <psonek2@seznam.cz>  Mon, 04 Mar 2013 09:02:00 +0100

qtmoko (53-1) unstable; urgency=low

  * fix DISPLAY in QX and Xfbdev incocation (Neil Jerram)
  * use GPSD for providing GPS data (Neil Jerram)
  * qgpsholder program for holding gps open

 -- Radek Polak <psonek2@seznam.cz>  Tue, 12 Feb 2013 19:09:00 +0100

qtmoko (52-1) unstable; urgency=low

  * media alsa state now saves 5mA
  * media alsa state is now louder
  * fixed "Draft message" instead of sender in SMS (Neil Jerram & Radek Polak)
  * fixed status to be uint64 in mail app db
  * fixed invisible text parts in qterminal
  * better config in mplayer
  * qui utility to show QtMoko message boxes from shell
  * support for armhf arch
  * better pulseaudio config
  * hack to restore brightness when POWER button is pressed

 -- Radek Polak <psonek2@seznam.cz>  Fri, 28 Dec 2012 21:26:00 +0100

qtmoko (51-1) unstable; urgency=low

  * upgrade to qt 4.8.3
  * support for html5 video in browsers
  * enable typing in the To field, when sending an email (Neil Jerram)
  * kill pulse.sh and pulseaudio when stopping QtMoko (Neil Jerram)
  * prevent pulseaudio from exiting every 20 seconds (Neil Jerram)
  * avoid "QString::arg: Argument missing" logs (Neil Jerram)
  * position is now showing in media player (Neil Jerram)
  * fixed qwslock log warnings (Neil Jerram)
  * cleaned up gta04 audio service (Neil Jerram)
  * have libQtScript and libQtDeclarative installed by qbuild (Gilles Filippini)
  * media player uses accelerometers for rotation
  * fixed wifi ap to not move around during rescan
  * bq27000_battery is now module so that you can rmmod it and use dumb battery
  * dmesg is included in /modem_reenumerate.log
  * qtmoko apt repo keys are installed by default
  * DISPLAY is no longer set in qpe.env to not confuse pulseaudio (Neil Jerram)
  * phonon is now built and can be used by applications
  * phonon has fix for swapped colors
  * QSplitter class is compiled for better compat with existing apps
  * rotate helper is now part of accelerometer library

 -- Radek Polak <psonek2@seznam.cz>  Fri, 21 Dec 2012 22:59:00 +0100

qtmoko (50-1) unstable; urgency=low

  * use /dev/mmcblk0p5 for media (/media/card mount)
  * fixed led blinking in suspend on incoming SMS
  * fixed ogg content (Neil Jerram)
  * debian package improvements (Gilles Filippini)
  * fixed swapped colors in videos

 -- Radek Polak <psonek2@seznam.cz>  Wed, 17 Nov 2012 21:09:00 +0100

qtmoko (49-1) unstable; urgency=low

  * using gstreamer as media engine instead of cruxus
  * using pulseaudio for sounds
  * using pasuspender to pause media during calls and state switching
  * fixed DTMF tones on gta04 (Neil Jerram)
  * fixed USSD message box size (Stefan Rupp)
  * A3 earpiece state uses HiFi priority (Neil Jerram)
  * modem is now in 3g mode since modem usb disconnect fix is in kernel
  * modem dissapearing from usb in now logged to /modem_reenumerate.log
  * lot of work on debian package (Gilles Filippini)
  * fixed pkg-config handling (Gilles Filippini)
  * ogg metadata plugin (Neil Jerram)
  * fixed empty email content with windows charset (Neil Jerram)
  * fixed some email content displaying (Neil Jerram)
  * fixes in QtMaze accelerometer (Neil Jerram)
  * improvements in svg layouts (adrien)
  * arora and qx use new accelerometer library (Neil Jerram)
  * arora provides web access e.g. for web links in email (Neil Jerram)
  * mokofaen - space for 10 and more satellites (Neil Jerram)
  * qmplayer scans for webm and mkv now too
  * ssh access in allowed only on usb now (Paul Ferster, lindi)
  * updated build instructions - cross building is now done in chroot
  * using now glib even loop
  * parallel make option in configure for -build-qt option
  * pc build
  * kernel changes:
  * external gps antenna should work now (Christoph Mair)
  * avoid errors by stoping omap DMA channels before unlinking (Neil Brown)
  * CONFIG_TIDSPBRIDGE=m so that we can use dsp
  * jffs2 as module so that we can mount hw validation in nand 
  * fixed modem disapearing from usb (Dr. H. Nikolaus Schaller)
  
 -- Radek Polak <psonek2@seznam.cz>  Wed, 07 Oct 2012 21:09:00 +0100

qtmoko (48-1) unstable; urgency=low

  * working alarm
  * working USSD on gta04 (Stefan Rupp)
  * handling of long USSD (Stefan Rupp)
  * fixed sound in calls on A3 (Neil Jerram)
  * better sound volume on A3 (Neil Jerram)
  * make gsm location working (Neil Jerram)
  * using /dev/input/incoming for leds signaling of SMS/call on gta04
  * race free suspend on gta04
  * updated mokofaen theme (Joif)


=== debian/control ===
Source: qtmoko
Section: comm
Priority: optional
Maintainer: Radek Polak <psonek2@seznam.cz>
Build-Depends: debhelper (>= 7.0.50~), libxext-dev, libasound2-dev, libdbus-1-dev, libssl-dev, libbluetooth-dev, libgps-dev, libxtst-dev, libpng12-dev, libv4l-dev, libspeexdsp-dev, libglib2.0-dev, libsqlite3-dev, libgstreamer-plugins-base0.10-dev, libtiff5-dev, libmng-dev, libpulse-dev, libvorbis-dev, quilt
Standards-Version: 3.9.2
Homepage: http://www.qtmoko.org
Vcs-Git: git://github.com/radekp/qtmoko.git
Vcs-Browser: https://github.com/radekp/qtmoko

Package: qtmoko-gta04
Provides: qtmoko
Conflicts: qtmoko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdbus-1-3, ttf-dejavu, psmisc, alsa-utils, ntpdate, gpsd, gpsd-clients
Description: Smartphone environment based on QT Extended - GTA04 flavor
 QtMoko provides a fully integrated phone stack plus smartphone environment
 for Linux based smartphones.
 .
 It is a fork of the discontinued Qt Extended product from Nokia.
 .
 Supported devices are those of the Openmoko community:
 * Neo 1973
 * Neo Freerunner
 * GTA04
 .
 This package ships the GTA04 flavor of QtMoko.

=== debian/rules ===
#!/usr/bin/make -f

# Squeeze support
ifeq (,$(DEB_HOST_MULTIARCH))
DEB_HOST_MULTIARCH:=$(DEB_HOST_GNU_TYPE)
DEB_BUILD_MULTIARCH:=$(DEB_BUILD_GNU_TYPE)
endif

# Cross-build settings
ifneq ($(DEB_HOST_MULTIARCH),$(DEB_BUILD_MULTIARCH))
CC=$(DEB_HOST_MULTIARCH)-gcc
CXX=$(DEB_HOST_MULTIARCH)-g++
CROSS_CPPFLAGS=
CROSS_INCDIR=
CROSS_LDFLAGS=
CROSS_LIBDIR=
else
CC=gcc
CXX=g++
CROSS_CPPFLAGS=
CROSS_INCDIR=
CROSS_LDFLAGS=
CROSS_LIBDIR=
endif

# Build flags for armel arch
ifeq (arm-linux-gnueabi,$(DEB_HOST_MULTIARCH))
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
CROSS_CPPFLAGS+=-fomit-frame-pointer -finline-functions -falign-functions=2 -falign-loops=2 -falign-jumps=2 -march=armv4t -mtune=arm920t -msoft-float
endif
endif

# Build flags for armhf flags (GTA04 only)
ifeq (arm-linux-gnueabihf,$(DEB_HOST_MULTIARCH))
# <http://processors.wiki.ti.com/index.php/Cortex-A8>
CROSS_CPPFLAGS+=-march=armv7-a -mtune=cortex-a8 -mfpu=neon -ftree-vectorize -mfloat-abi=hard
# Avoid "Error: selected processor does not support Thumb mode `swp r6,r4,[r0]'"
# <http://pandaboard.org/pbirclogs//index.php?date=2011-07-10>
# at 17:05:14 and 17:30:26
CROSS_CPPFLAGS+=-marm
endif

# Add dpkg-buildflags settings
QMAKE_CFLAGS=-pipe $(shell CC=$(CC) dpkg-buildflags --get CFLAGS) $(CROSS_CPPFLAGS)
QMAKE_LDFLAGS=$(shell CC=$(CC) dpkg-buildflags --get LDFLAGS) $(CROSS_LDFLAGS)

# Configure flags
# ---------------
# Force target architecture
CONFIGURE_FLAGS := -arch $(DEB_HOST_GNU_CPU)

# No pkgmanagement - everything should be handled the Debian way
CONFIGURE_FLAGS += -remove-module pkgmanagement

# Languages
LANGUAGES := $(shell ls i18n/ | xargs echo | sed 's/ /,/g')
CONFIGURE_FLAGS += -languages $(LANGUAGES)

# Use system librairies where possible
CONFIGURE_FLAGS += -extra-qt-embedded-config="-system-sqlite -system-libtiff -system-libmng"

# The configure step defaults to '-build-qt'. If QTMOKO_SYSTEM_QT isn't
# empty, we use 'system-qt' instead. 
ifneq (,$(QTMOKO_SYSTEM_QT))
SYSTEM_QT_BUILD_DEPS := , libqt4-dev, libqt4-sql-sqlite
CONFIGURE_FLAGS += -system-qt
else
# Shorten native Qt build
# -release: avoid dependency on gdb
# -static:  avoid setting LD_LIBRARY_PATH at make install step
# TO DO: check whether sqlite is actually needed
CONFIGURE_FLAGS += -extra-qt-config="-release -static -system-sqlite -no-gif -nomake tools -no-declarative"
endif

# Use toolchain linux-native-g++ (from device mkspecs)
TOOLCHAIN := linux-native-g++
QMAKE_CONF = devices/$1/mkspecs/qws/$(TOOLCHAIN)/qmake.conf
CONFIGURE_FLAGS += -xplatform $(TOOLCHAIN)
# ---------------

# Force our pkg-config wrapper
export PKG_CONFIG=$(CURDIR)/pkg-config-cross
# PKG_CONFIG_PATH to use for target system; See devices/<device>/environment
export QTMOKO_PKG_CONFIG_PATH=/usr/$(DEB_HOST_MULTIARCH)/lib/pkgconfig

# /!\ Ugly workaround to have cross libpulsecommon-2.0.so which isn't
# handled by xapt + dpkg-cross starting from wheezy
# It requires "dpkg --add-architecture $(DEB_HOST_MULTIARCH)" in the chroot
# Hopefully all this crap won't be needed with true multiarch enabled cross
# toolchains
ifneq ($(DEB_HOST_MULTIARCH),$(DEB_BUILD_MULTIARCH))
ifeq (OK,$(shell if dpkg --compare-versions "$(shell dpkg -l dpkg | grep ^ii | awk '{print $$3}')" '>=' "1.16.2"; then echo "OK"; fi))
LIBPULSECOMMON_CROSS := libpulsecommon-cross
QMAKE_LDFLAGS += -Wl,-rpath-link,$(CURDIR)/pulseaudio-cross/usr/lib/$(DEB_HOST_MULTIARCH)/pulseaudio
endif
endif

# Retrieve Qt version from sources
QT_VERSION := $(shell grep '^\# *define *QT_VERSION_STR' "qtopiacore/qt/src/corelib/global/qglobal.h" | awk '{print $$3}')

# Tell quilt where to look for specific patches
export QUILT_PATCHES=debian/patches

# Devices to build QtMoko for
QTMOKO_DEVICES ?= gta04 neo pc


%:
	dh $@

libpulsecommon-cross:
	mkdir pulseaudio-cross
	cd pulseaudio-cross && apt-get download libpulse0:$(DEB_HOST_ARCH)
	cd pulseaudio-cross && dpkg -x libpulse0_*.deb .

clean: $(foreach device,$(QTMOKO_DEVICES),gen_control_$(device))
gen_control:
	sed 's/@SYSTEM_QT@/'"$(SYSTEM_QT_BUILD_DEPS)"'/' debian/control-src >debian/control
gen_control_%: DEVICE=$(patsubst gen_control_%,%,$@)
gen_control_%: gen_control
	cat debian/control-$(DEVICE) >>debian/control


configure_main: $(LIBPULSECOMMON_CROSS)
	# Qt-4.8 specific patches
#	if [ "$$(echo "4.8\n$(QT_VERSION)" | sort -V | head -1)" = "4.8" ]; then \
#		if [ "$$(basename "$$(readlink -f debian/patches/series)")" = "series-main" ]; then \
#			rm -fr .pc; \
#		fi; \
#		ln -fs series-qt48 debian/patches/series; \
#		quilt push -a; \
#	fi

override_dh_auto_configure: $(foreach device,$(QTMOKO_DEVICES),configure_$(device))
configure_%: DEVICE=$(patsubst configure_%,%,$@)
configure_%: configure_main
	# Patch the qmake.conf file with proper toolchain configuration
	sed -i.orig \
		-e 's:^\(QMAKE_CC[ \t]*=\).*$$:\1 '"$(CC):" \
		-e 's:^\(QMAKE_CXX[ \t]*=\).*$$:\1 '"$(CXX):" \
		-e 's:^\(QMAKE_LINK[ \t]*=\).*$$:\1 '"$(CXX):" \
		-e 's:^\(QMAKE_LINK_SHLIB[ \t]*=\).*$$:\1 '"$(CXX):" \
		-e 's:^\(QMAKE_CFLAGS[ \t]*=\).*$$:\1 '"$(QMAKE_CFLAGS):" \
		-e 's:^\(QMAKE_CFLAGS_RELEASE[ \t]*=\).*$$:\1 :' \
		-e 's:^\(QMAKE_CFLAGS_DEBUG[ \t]*=\).*$$:\1 :' \
		-e 's:^\(QMAKE_INCDIR[ \t]*=\).*$$:\1 '"$(CROSS_INCDIR):" \
		-e 's:^\(QMAKE_LIBDIR[ \t]*=\).*$$:\1 '"$(CROSS_LIBDIR):" \
		-e 's:^\(QMAKE_LFLAGS[ \t]*=\).*$$:\1 '"$(QMAKE_LDFLAGS):" \
		-e 's:^\(QMAKE_LIBS[ \t]*=\).*$$:\1 '"-ldl:" \
		$(call QMAKE_CONF,$(DEVICE)); \
	# Qt Extended configuration step
	mkdir -p ../build-$(DEVICE)
	cd ../build-$(DEVICE) && "$(CURDIR)/configure" -device $(DEVICE) $(CONFIGURE_FLAGS)

override_dh_auto_build: $(foreach device,$(QTMOKO_DEVICES),build_$(device))
build_%: DEVICE=$(patsubst build_%,%,$@)
build_%:
	$(MAKE) -C ../build-$(DEVICE)


override_dh_auto_clean: $(foreach device,$(QTMOKO_DEVICES),clean_$(device))
	# If needed, revert QT_VERSION specific patches
	if [ "$$(basename "$$(readlink -f debian/patches/series)")" != "series-main" ]; then \
		if quilt app; then \
			quilt pop -a; \
		fi && \
		ln -fs series-main debian/patches/series; \
	fi
	rm -f sdk/LICENSE.QtopiaGPL
ifneq (,$(LIBPULSECOMMON_CROSS))
	rm -fr pulseaudio-cross
endif

clean_%: DEVICE=$(patsubst clean_%,%,$@)
clean_%:
	[ ! -f $(call QMAKE_CONF,$(DEVICE)).orig ] || mv $(call QMAKE_CONF,$(DEVICE)).orig $(call QMAKE_CONF,$(DEVICE))
	rm -fr ../build-$(DEVICE)


override_dh_auto_install: $(foreach device,$(QTMOKO_DEVICES),install_$(device))

install_%: DEVICE=$(patsubst install_%,%,$@)
install_%:
	$(MAKE) -C ../build-$(DEVICE) install
	mkdir -p debian/tmp-$(DEVICE)/opt/qtmoko
	cp -rd ../build-$(DEVICE)/image/* debian/tmp-$(DEVICE)/opt/qtmoko

	# remove patented stuff - can be installed via package later
	rm -f debian/tmp-$(DEVICE)/opt/qtmoko/plugins/codecs/libmadplugin.so
	rm -f debian/tmp-$(DEVICE)/opt/qtmoko/lib/libmad.so.0

	# symlink to ttfont installed together with X
	rm -rf debian/tmp-$(DEVICE)/opt/qtmoko/lib/fonts


override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/qtmoko-$(word 1,$(QTMOKO_DEVICES))/opt/qtmoko/lib:/usr/$(DEB_HOST_MULTIARCH)/lib \
		-- $(foreach device,$(QTMOKO_DEVICES),-xqtmoko-$(device))


get-orig-source: VERSION=$(shell dpkg-parsechangelog | grep '^Version:' | awk '{print $$2}' | sed 's/\(.*\)-[^-]*/\1/')
get-orig-source: clean
	! quilt app || quilt pop -a
	tar caf $(CURDIR)/../qtmoko_$(VERSION).orig.tar.gz --exclude .pc --exclude .git --exclude $$(basename $(CURDIR))/debian -C $(CURDIR)/.. $$(basename $(CURDIR))
